#include <iostream.h>
#include "mat.h"

int inv_mat(double **mat,int N){
  double **gmat=mat_alloc(N,2*N); //Creamos una matriz que sirva para calcular la inversa
  for (int i=0;i<N;i++){
    for (int j=0;j<N;j++) {
       gmat[i][j]=mat[i][j]; //Una mitad es nuestra matriz
       gmat[i][j+N]=delta(i,j); //Inicializamos la otra mitad como la identidad 
    }
  }

  for(int indc=0;indc<N;indc++){ // recorremos las tres primera columnas
    for (int indf=indc;gmat[indc][indc]==0; indf++){ //Si el primer elemento es cero, entonces conmutamos filas.
      if (indf==N){
    cerr<< "Error: La matriz no es invertible" <<endl; //si conmutamos todas las filas y no hay ninguno cero la matriz no es invertible, esto es suficiente, ya que la ultima fila sera de puros ceros si es que la matriz no es invertible y la condicion fallara en ese caso (claro que uso tiempo de CPU).
	return 1;
      }
     conm_mat(gmat,N,2*N,indc,indf);//aca conmuta las filas 
    }
    mult_mat(gmat,N,2*N,indc,1/gmat[indc][indc]); //hacemos que esa fila empieze con 1.
    for (int indf=0; indf<N; indf++){
      if (indc!=indf) sum_mat(gmat,N,2*N,indf,indc,-1*gmat[indf][indc]); //matamos las filas restantes en esa columna cuidando no matar a si misma
    }
  }
  for(int i=0;i<N;i++) for(int j=0;j<N;j++) mat[i][j]=gmat[i][N+j]; // La que queda en la otra mitad es la matriz inversa y la ponemos en lugar de la matriz original
  mat_free(gmat,N,2*N); //liberamos la memoria usada
return 0;
}
