#include <iostream.h>
#include <fstream.h>
#include "mat.h"
double ** mat_alloc(int N,int M){
  double ** rval=new double*[N]; // Crea un arreglo de punteros
  for (int i=0;i<N;i++) rval[i]=new double[M]; //rval[i] es un puntero a un arreglo que se inicializa con M elementos;
  for (int i=0;i<N;i++){
    for (int j=0;j<M;j++){
      rval[i][j]=0; //inicializamos a cero todos los componentes
    }
  }
  return rval; //retornamos el puntero a la nueva matriz
}
void mat_free(double ** mat, int N, int M){
  for (int i=0;i<N;i++){
    delete [] mat[i]; //Libera los arreglos de M elementos
  }
  delete [] mat; //Libera el arreglo de arreglos
}
void read_mat(double **mat,int N,int M){
  for (int i=0;i<N;i++){
    for (int j=0;j<M;j++){
      cin >> mat[i][j]; //Recorre la matriz por filas leyendo los valores desde cin
    }
  }
}
void write_mat(double ** mat,int N,int M){
  for (int i=0;i<N;i++){
    for (int j=0;j<M;j++){
      cout << mat[i][j]<< " "; //Recorre los valores tirandolos a cout
    }
    cout <<endl; // cada nueva fila tira un endl.
  }
}
int mult_mat(double ** mat,int N,int M, int fila,double multi){
  if (M<=fila){
    cerr<< "Error: no existe esa fila" <<endl;
 return 1;
  } //Si no existe esa fila da error 
  if(multi==0.0){
    cerr<< "Error: no se puede multiplicar por una fila por 0" <<endl;
 return 2;
  } //Si el numero es 0 da error
  for (int j=0;j<M;j++) mat[fila][j]*=multi; //multiplica la fila por el numero
  return 0; // no hubo errores devolvemos 0
}
int conm_mat(double ** mat,int N,int M, int fila1,int fila2){
  if (M<=fila1){
    cerr<< "Error: no existe esa fila" <<endl;
 return 1;
  } //Si no existe esa fila da error 
  if(M<=fila2){
    cerr<< "Error: no existe esa fila" <<endl;
 return 1;
  } //Si no existe esa fila da error 
  if(fila1==fila2) return 0; //Si las filas son la misma, no haga nada 
  double *buffer=new double[M]; //creamos un buffer para almacenar temporalmente el valor 
  for (int j=0;j<M;j++){
    buffer[j]=mat[fila1][j]; //almacenamos la fila1 en el buffer
  }
  for (int j=0;j<M;j++){
    mat[fila1][j]=mat[fila2][j]; //ponemos la fila2 en la 1
    mat[fila2][j]=buffer[j]; //leemos la fila1 del buffer y la ponemos en la fila2
  }
  return 0; //no hubo errores devolvemos 0
}

int sum_mat(double **mat,int N,int M,int fila1,int fila2,double multi){
  if(M<=fila1){
    cerr<< "Error: no existe esa fila" <<endl;
 return 1;
  } //Si no existe esa fila da error 
  if(M<=fila2){
    cerr<< "Error: no existe esa fila" <<endl;
 return 1;
  } //Si no existe esa fila da error 
  if(fila1==fila2){
    cerr<< "Error: no se puede aplicar sobre la misma fila" <<endl;
 return 2;
  } //Si trata de operar sobre la misma fila
  for (int j=0;j<M;j++){
    mat[fila1][j]+=multi*mat[fila2][j];//suma a la fila1 la fila2 *multi
  }
  return 0; // no hubo errores devolvemos 0
}

double delta(int i,int j){
  return (i==j)?1:0; // si son iguales devuelve 1 si no 0
}
