#ifndef MAT_H //Evita que sea incluido multiples veces
#define MAT_H
#include <stdlib.h>
/* Aca van las declaraciones de las funciones que se usaran en el programa, y en mat.cc estas las definiciones.
Como matriz usaremos un arreglo de arreglos lineales */ 

/* FUNCIONES DE MANEJO BASICO DE MATRICES */


double ** mat_alloc(int N,int M); // Crea en memoria dinamica una matriz de NxM, debe ser liberada despues con mat_free(), devuelve NULL en caso de error. El arreglo es llenado a 0. El tamano del arreglo es [N][M]

void mat_free(double ** mat,int N,int M); //Libera la memoria usada por una matriz.

void read_mat(double ** mat,int N,int M); // Lee una matriz del stdin y la pone en la matriz que se dio por argumento.
void write_mat(double ** mat,int N,int M); //Escribe la matriz al stdout.

/* TRANSFORMACIONES ELEMENTALES DE MATRICES POR FILAS*/

//estas retornan 1 en caso de error
int mult_mat(double ** mat,int N,int M, int fila,double multi); //Multiplica una fila por un numero
int conm_mat(double ** mat,int N,int M, int fila1,int fila2); //conmuta dos filas de la matriz
int sum_mat(double **mat,int N,int M,int fila1,int fila2,double multi); //Suma a la fila1 en los argumentos, la fila2 por un numero multi != 0.

/* OTRAS FUNCIONES */
double delta(int i,int j); //La delta de kronecker
#endif
